"""Remove held messages from a mailing list.

This script remove messages sent by the given address from a mailing list.

It is intended to be run to remove spammer messages from the system. You can
create a wrapper to feed list names.

% bin/withlist -l -r del_held_messages <listname> <address>

Written by Xueshan Feng <sfeng@stanford.edu>

"""

from Mailman.mm_cfg import DISCARD
 
def del_held_messages(mlist, addr):
    pendingmsgs = mlist.GetHeldMessageIds()
    if not pendingmsgs:
        return 0
    for id in pendingmsgs:
        requestaddr = mlist.GetRecord(id)[1]
        if requestaddr in ( addr ):
            print 'Discard listname: %s, addr: %s' % (mlist.real_name, requestaddr)
            # Comment this out if dry-run
            mlist.HandleRequest(id,DISCARD)
            mlist.Save()

